package ru.landrafhomyak.utility.reference_counter

import kotlin.jvm.JvmStatic

@Suppress("ClassName")
internal object _Misc {
	@JvmStatic
	internal inline fun _compareAndExchange(get: () -> Long, cas: (Long, Long) -> Boolean, expected: Long, newValue: Long): Long {
		while (true) {
			val old = get()
			if (old != expected) return old
			if (cas(old, newValue)) return old
		}
	}

	internal const val CLOSED_STATE_VALUE = -0x4000_0000_0000_0000L
}